package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsOrderSettleExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsOrderSettleExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMerNoIsNull() {
            addCriterion("mer_no is null");
            return (Criteria) this;
        }

        public Criteria andMerNoIsNotNull() {
            addCriterion("mer_no is not null");
            return (Criteria) this;
        }

        public Criteria andMerNoEqualTo(String value) {
            addCriterion("mer_no =", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotEqualTo(String value) {
            addCriterion("mer_no <>", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoGreaterThan(String value) {
            addCriterion("mer_no >", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoGreaterThanOrEqualTo(String value) {
            addCriterion("mer_no >=", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoLessThan(String value) {
            addCriterion("mer_no <", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoLessThanOrEqualTo(String value) {
            addCriterion("mer_no <=", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoLike(String value) {
            addCriterion("mer_no like", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotLike(String value) {
            addCriterion("mer_no not like", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoIn(List<String> values) {
            addCriterion("mer_no in", values, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotIn(List<String> values) {
            addCriterion("mer_no not in", values, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoBetween(String value1, String value2) {
            addCriterion("mer_no between", value1, value2, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotBetween(String value1, String value2) {
            addCriterion("mer_no not between", value1, value2, "merNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoIsNull() {
            addCriterion("settle_mer_no is null");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoIsNotNull() {
            addCriterion("settle_mer_no is not null");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoEqualTo(String value) {
            addCriterion("settle_mer_no =", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoNotEqualTo(String value) {
            addCriterion("settle_mer_no <>", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoGreaterThan(String value) {
            addCriterion("settle_mer_no >", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoGreaterThanOrEqualTo(String value) {
            addCriterion("settle_mer_no >=", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoLessThan(String value) {
            addCriterion("settle_mer_no <", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoLessThanOrEqualTo(String value) {
            addCriterion("settle_mer_no <=", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoLike(String value) {
            addCriterion("settle_mer_no like", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoNotLike(String value) {
            addCriterion("settle_mer_no not like", value, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoIn(List<String> values) {
            addCriterion("settle_mer_no in", values, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoNotIn(List<String> values) {
            addCriterion("settle_mer_no not in", values, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoBetween(String value1, String value2) {
            addCriterion("settle_mer_no between", value1, value2, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerNoNotBetween(String value1, String value2) {
            addCriterion("settle_mer_no not between", value1, value2, "settleMerNo");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyIsNull() {
            addCriterion("settle_mer_key is null");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyIsNotNull() {
            addCriterion("settle_mer_key is not null");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyEqualTo(String value) {
            addCriterion("settle_mer_key =", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyNotEqualTo(String value) {
            addCriterion("settle_mer_key <>", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyGreaterThan(String value) {
            addCriterion("settle_mer_key >", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyGreaterThanOrEqualTo(String value) {
            addCriterion("settle_mer_key >=", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyLessThan(String value) {
            addCriterion("settle_mer_key <", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyLessThanOrEqualTo(String value) {
            addCriterion("settle_mer_key <=", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyLike(String value) {
            addCriterion("settle_mer_key like", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyNotLike(String value) {
            addCriterion("settle_mer_key not like", value, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyIn(List<String> values) {
            addCriterion("settle_mer_key in", values, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyNotIn(List<String> values) {
            addCriterion("settle_mer_key not in", values, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyBetween(String value1, String value2) {
            addCriterion("settle_mer_key between", value1, value2, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleMerKeyNotBetween(String value1, String value2) {
            addCriterion("settle_mer_key not between", value1, value2, "settleMerKey");
            return (Criteria) this;
        }

        public Criteria andSettleAmountIsNull() {
            addCriterion("settle_amount is null");
            return (Criteria) this;
        }

        public Criteria andSettleAmountIsNotNull() {
            addCriterion("settle_amount is not null");
            return (Criteria) this;
        }

        public Criteria andSettleAmountEqualTo(BigDecimal value) {
            addCriterion("settle_amount =", value, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountNotEqualTo(BigDecimal value) {
            addCriterion("settle_amount <>", value, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountGreaterThan(BigDecimal value) {
            addCriterion("settle_amount >", value, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("settle_amount >=", value, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountLessThan(BigDecimal value) {
            addCriterion("settle_amount <", value, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("settle_amount <=", value, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountIn(List<BigDecimal> values) {
            addCriterion("settle_amount in", values, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountNotIn(List<BigDecimal> values) {
            addCriterion("settle_amount not in", values, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("settle_amount between", value1, value2, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andSettleAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("settle_amount not between", value1, value2, "settleAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagIsNull() {
            addCriterion("ledger_flag is null");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagIsNotNull() {
            addCriterion("ledger_flag is not null");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagEqualTo(Boolean value) {
            addCriterion("ledger_flag =", value, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagNotEqualTo(Boolean value) {
            addCriterion("ledger_flag <>", value, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagGreaterThan(Boolean value) {
            addCriterion("ledger_flag >", value, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagGreaterThanOrEqualTo(Boolean value) {
            addCriterion("ledger_flag >=", value, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagLessThan(Boolean value) {
            addCriterion("ledger_flag <", value, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagLessThanOrEqualTo(Boolean value) {
            addCriterion("ledger_flag <=", value, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagIn(List<Boolean> values) {
            addCriterion("ledger_flag in", values, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagNotIn(List<Boolean> values) {
            addCriterion("ledger_flag not in", values, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagBetween(Boolean value1, Boolean value2) {
            addCriterion("ledger_flag between", value1, value2, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerFlagNotBetween(Boolean value1, Boolean value2) {
            addCriterion("ledger_flag not between", value1, value2, "ledgerFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoIsNull() {
            addCriterion("ledger_order_no is null");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoIsNotNull() {
            addCriterion("ledger_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoEqualTo(String value) {
            addCriterion("ledger_order_no =", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoNotEqualTo(String value) {
            addCriterion("ledger_order_no <>", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoGreaterThan(String value) {
            addCriterion("ledger_order_no >", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("ledger_order_no >=", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoLessThan(String value) {
            addCriterion("ledger_order_no <", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoLessThanOrEqualTo(String value) {
            addCriterion("ledger_order_no <=", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoLike(String value) {
            addCriterion("ledger_order_no like", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoNotLike(String value) {
            addCriterion("ledger_order_no not like", value, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoIn(List<String> values) {
            addCriterion("ledger_order_no in", values, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoNotIn(List<String> values) {
            addCriterion("ledger_order_no not in", values, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoBetween(String value1, String value2) {
            addCriterion("ledger_order_no between", value1, value2, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerOrderNoNotBetween(String value1, String value2) {
            addCriterion("ledger_order_no not between", value1, value2, "ledgerOrderNo");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountIsNull() {
            addCriterion("ledger_amount is null");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountIsNotNull() {
            addCriterion("ledger_amount is not null");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountEqualTo(BigDecimal value) {
            addCriterion("ledger_amount =", value, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountNotEqualTo(BigDecimal value) {
            addCriterion("ledger_amount <>", value, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountGreaterThan(BigDecimal value) {
            addCriterion("ledger_amount >", value, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ledger_amount >=", value, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountLessThan(BigDecimal value) {
            addCriterion("ledger_amount <", value, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ledger_amount <=", value, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountIn(List<BigDecimal> values) {
            addCriterion("ledger_amount in", values, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountNotIn(List<BigDecimal> values) {
            addCriterion("ledger_amount not in", values, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ledger_amount between", value1, value2, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ledger_amount not between", value1, value2, "ledgerAmount");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusIsNull() {
            addCriterion("ledger_status is null");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusIsNotNull() {
            addCriterion("ledger_status is not null");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusEqualTo(Integer value) {
            addCriterion("ledger_status =", value, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusNotEqualTo(Integer value) {
            addCriterion("ledger_status <>", value, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusGreaterThan(Integer value) {
            addCriterion("ledger_status >", value, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("ledger_status >=", value, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusLessThan(Integer value) {
            addCriterion("ledger_status <", value, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusLessThanOrEqualTo(Integer value) {
            addCriterion("ledger_status <=", value, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusIn(List<Integer> values) {
            addCriterion("ledger_status in", values, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusNotIn(List<Integer> values) {
            addCriterion("ledger_status not in", values, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusBetween(Integer value1, Integer value2) {
            addCriterion("ledger_status between", value1, value2, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andLedgerStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("ledger_status not between", value1, value2, "ledgerStatus");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoIsNull() {
            addCriterion("revoke_order_no is null");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoIsNotNull() {
            addCriterion("revoke_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoEqualTo(String value) {
            addCriterion("revoke_order_no =", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoNotEqualTo(String value) {
            addCriterion("revoke_order_no <>", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoGreaterThan(String value) {
            addCriterion("revoke_order_no >", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("revoke_order_no >=", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoLessThan(String value) {
            addCriterion("revoke_order_no <", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoLessThanOrEqualTo(String value) {
            addCriterion("revoke_order_no <=", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoLike(String value) {
            addCriterion("revoke_order_no like", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoNotLike(String value) {
            addCriterion("revoke_order_no not like", value, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoIn(List<String> values) {
            addCriterion("revoke_order_no in", values, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoNotIn(List<String> values) {
            addCriterion("revoke_order_no not in", values, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoBetween(String value1, String value2) {
            addCriterion("revoke_order_no between", value1, value2, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andRevokeOrderNoNotBetween(String value1, String value2) {
            addCriterion("revoke_order_no not between", value1, value2, "revokeOrderNo");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}